// Con Clase Enero 2024
// Ejemplo de lectura de fochero XML
// Añadir en las opciones de compilador:
// xml2.dll para usar la versión dinámica de libxml2

#include <iostream>
#include <string>
#include <libxml/tree.h>
#include <windows.h>

void MostrarHijos(xmlNodePtr, int);
void MostrarAtributos(xmlAttrPtr);

int main()
{
    xmlDocPtr doc;
    xmlNodePtr node;

    LIBXML_TEST_VERSION
    SetConsoleOutputCP(CP_UTF8);

//    doc = xmlReadFile("xml_tree.cbp", NULL, XML_PARSE_NOBLANKS);
    doc = xmlReadFile("ejemplo.xml", NULL, XML_PARSE_NOBLANKS);
    std::cout << "Nombre: " << doc->URL << std::endl;
    std::cout << "Version: " << doc->version << std::endl;
    std::cout << "Codificacion: " << doc->encoding << std::endl;
    std::cout << "Numero de hijos: " << xmlChildElementCount((xmlNodePtr)doc->children) << std::endl;
    node = doc->children;
    MostrarHijos(node, 0);

    node = doc->children;
    node = node->children;
    node = node->next;
    node = node->children;
    node = node->next;
    node = node->children;
    node = node->next;
    std::cout << "\nPath: " << xmlGetNodePath(node) << std::endl;
    xmlFreeDoc(doc);
    xmlCleanupParser();
    return 0;
}

void MostrarHijos(xmlNodePtr node, int nivel) {
    while(node) {
        if(node->type == XML_ELEMENT_NODE) {
            std::cout << std::endl;
            for(int i=0; i<nivel; i++) std::cout << ' ';
            std::cout << "Elemento: " << node->name << " - ";
            MostrarAtributos(node->properties);
        } else
        if(node->type == XML_TEXT_NODE || node->type == XML_COMMENT_NODE) { // Comentarios o texto
            if(!xmlIsBlankNode(node)) {
                std::cout << " Nodo tipo(" << node->type << ") " << node->name << " - " << node->content;
            }
        }
        MostrarHijos(node->children, nivel+1);
        node = node->next;
    }
}

void MostrarAtributos(xmlAttrPtr prop) {
    while(prop) {
        if(prop->type == XML_ATTRIBUTE_NODE) {
            std::cout << " " << prop->name;
            std::cout << "(" << prop->children->content << ") ";
        }
        prop = prop->next;
    }
}
